// Par P. GUYADER - Tous droits réservés - 2016 - GPLv3

// Test de vitesse des servo-moteurs Gauche et Droit

// -----------------------------------Les librairies
#include <Servo.h>
#include <Utils.h>
#include <UtilsServo.h>

// -----------------------------------Les Objets
Servo servoG; //-----------Cré un objet ServoGauche
Servo servoD; //-----------Cré un objet servoDroit
Utils utils;  //-----------Cré un objet Utils 

//------------------------------------Les constantes
String     ChaineReception = "";
const int  Pin = 14;
String     Test   = "Mauvais"; 
int        Impuls = 1500 ; 
//------------------------------------Fin Constantes

//------------------------------------Début setup
void setup(){
  Serial.begin(115200);    // Initialise la liaison série
  servoG.attach(Pin);      // Attribue la broche 14 au servo 
  // Description des instructions attendues par Arduino 
  Serial.println("vous devez envoyer une instruction du type +xxx ou -xxx");
  Serial.println("par exemple +20 ou -300, cette valeur est ajoutee à la valeur de l'impulsion");
  Serial.println("la valeur initiale de l'impulsion est de: 1500");
  Serial.println("Arduino attend vos instructions....");
  }
//-------------------- Fin setup

//-------------------- Début loop  
void loop(){ 
  //-----------------Lecture et affichage de l'instruction reçue 
  ChaineReception = utils.waitingString();                                // lit la chaine sur le port série
  if (ChaineReception != ""){                                             // ChaineReception à reçu une instruction 
    Serial.print("Arduino a lu:  "); Serial.println(ChaineReception);     // Affiche le message reçu
  }
    //---------------Decryptage de l'instruction
  if ((ChaineReception.startsWith("+")) or (ChaineReception.startsWith("-"))){  // l'instruction commence par + ou -
    Impuls = Impuls + ChaineReception.toInt();                                  // conversion en int
    if (Impuls > 2600) {Impuls = 2600;}                                         // limite supérieure de Impuls 
    if (Impuls < 400)  {Impuls = 400;}                                          // limite inférieure de Impuls
    Test = "Bon";                                                               // Résultat du test 
    }    //----------Fin test 
   
  else{
    if(ChaineReception != ""){                        // Affichage mauvaise instruction
      Serial.println("mauvaise instruction");
      Test = "Mauvais";
    }                                                 // Fin mauvaise instruction
  }
  //------------- Fin Décryptage
  
  //------------- Envoi instruction moteur
  if ( Test == "Bon" ){
      servoG.writeMicroseconds(Impuls);                                                // envoi de Impuls au moteur
      Serial.print("  Valeur adressee au servo-moteur: ");Serial.println(Impuls);      // Affiche la nouvelle valeur de Impuls 
      Test = "Mauvais";
      }
  
  ChaineReception = "";                       // remise à zero de ChaineReception
  delay(500);  
  }   // Fin loop

  


                                                 
